package com.loafle.overflow.model.meta;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 * Created by snoop on 17. 6. 26.
 */
@Entity
@Table(name = "META_NOAUTH_PROBE_STATUS", schema = "public")
public class MetaNoAuthProbeStatus {
  private Short id;
  private String key;
  private String name;
  private Date createDate;

  public MetaNoAuthProbeStatus() {

  }

  public MetaNoAuthProbeStatus(Short id) {
    this.id = id;
  }

  @Id
  public Short getId() {
    return id;
  }

  public void setId(Short id) {
    this.id = id;
  }

  @Column(name = "KEY", nullable = true, length = 50)
  public String getKey() {
    return key;
  }

  public void setKey(String key) {
    this.key = key;
  }

  @Column(name = "Name", nullable = false, length = 10)
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  @Temporal(TemporalType.TIMESTAMP)
  @Column(name = "CREATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
  public Date getCreateDate() {
    return createDate;
  }

  public void setCreateDate(Date createDate) {
    this.createDate = createDate;
  }

  public static enum Enum {
    ACCEPTED((short)1),
    DENIED((short)2),
    PROCESSING((short)3),
    ;

    private final Short value;

    /**
     * @param value
     */
    Enum(final Short value) {
      this.value = value;
    }

    public MetaNoAuthProbeStatus to() {
      return new MetaNoAuthProbeStatus(this.value);
    }
  }

}
