package com.loafle.overflow.model.noauthprobe;

import com.loafle.overflow.model.domain.Domain;
import com.loafle.overflow.model.meta.MetaNoAuthProbeStatus;
import com.loafle.overflow.model.probe.Probe;

import javax.persistence.*;
import java.util.Date;

/**
 * Created by root on 17. 6. 22.
 */
@Entity
@Table(name = "NOAUTH_PROBE", schema = "public")
public class NoAuthProbe {
  private Long id;
  private Domain domain;
  private Probe probe;
  private MetaNoAuthProbeStatus metaNoAuthProbeStatus;
  private String description;
  private String tempProbeKey;
  private String apiKey;
  private Date connectDate;
  private String connectAddress;
  private Date createDate;

  @Id
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  @Column(name = "DESCRIPTION", nullable = true, length = 1000)
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  @ManyToOne
  @JoinColumn(name = "META_NOAUTH_PROBE_STATUS_ID", nullable = false)
  public MetaNoAuthProbeStatus getMetaNoAuthProbeStatus() {
    return metaNoAuthProbeStatus;
  }

  public void setMetaNoAuthProbeStatus(MetaNoAuthProbeStatus metaNoAuthProbeStatus) {
    this.metaNoAuthProbeStatus = metaNoAuthProbeStatus;
  }

  @Column(name = "TEMP_PROBE_KEY", nullable = false, length = 50, unique = true)
  public String getTempProbeKey() {
    return tempProbeKey;
  }

  public void setTempProbeKey(String tempProbeKey) {
    this.tempProbeKey = tempProbeKey;
  }

  @Temporal(TemporalType.TIMESTAMP)
  @Column(name = "CREATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
  public Date getCreateDate() {
    return createDate;
  }

  public void setCreateDate(Date createDate) {
    this.createDate = createDate;
  }

  @Column(name = "API_KEY", nullable = true, length = 50)
  public String getApiKey() {
    return apiKey;
  }

  public void setApiKey(String apiKey) {
    this.apiKey = apiKey;
  }

  @ManyToOne
  @JoinColumn(name = "DOMAIN_ID", nullable = false)
  public Domain getDomain() {
    return domain;
  }

  public void setDomain(Domain domain) {
    this.domain = domain;
  }

  @ManyToOne
  @JoinColumn(name = "PROBE_ID", nullable = true)
  public Probe getProbe() {
    return probe;
  }

  public void setProbe(Probe probe) {
    this.probe = probe;
  }

  @Temporal(TemporalType.TIMESTAMP)
  @Column(name = "CONNECT_DATE", nullable = true)
  public Date getConnectDate() {
    return connectDate;
  }

  public void setConnectDate(Date connectDate) {
    this.connectDate = connectDate;
  }

  @Column(name = "CONNECT_ADDRESS", nullable = true, length = 50)
  public String getConnectAddress() {
    return connectAddress;
  }

  public void setConnectAddress(String connectAddress) {
    this.connectAddress = connectAddress;
  }

  // @Override
  // public boolean equals(Object o) {
  // if (this == o) return true;
  // if (o == null || getClass() != o.getClass()) return false;
  //
  // NoAuthProbe that = (NoAuthProbe) o;
  //
  // if (id != that.id) return false;
  // if (domainId != that.domainId) return false;
  // if (hostName != null ? !hostName.equals(that.hostName) : that.hostName !=
  // null) return false;
  // if (macAddress != null ? !macAddress.equals(that.macAddress) :
  // that.macAddress != null) return false;
  // if (ipAddress != null ? !ipAddress.equals(that.ipAddress) : that.ipAddress !=
  // null) return false;
  // if (status != null ? !status.equals(that.status) : that.status != null)
  // return false;
  // if (tempProbeKey != null ? !tempProbeKey.equals(that.tempProbeKey) :
  // that.tempProbeKey != null) return false;
  // if (createDate != null ? !createDate.equals(that.createDate) :
  // that.createDate != null) return false;
  // if (apiKey != null ? !apiKey.equals(that.apiKey) : that.apiKey != null)
  // return false;
  // if (probeId != null ? !probeId.equals(that.probeId) : that.probeId != null)
  // return false;
  //
  // return true;
  // }
  //
  // @Override
  // public int hashCode() {
  // int result = (int) (id ^ (id >>> 32));
  // result = 31 * result + (hostName != null ? hostName.hashCode() : 0);
  // result = 31 * result + (macAddress != null ? macAddress.hashCode() : 0);
  // result = 31 * result + (ipAddress != null ? ipAddress.hashCode() : 0);
  // result = 31 * result + (status != null ? status.hashCode() : 0);
  // result = 31 * result + (tempProbeKey != null ? tempProbeKey.hashCode() : 0);
  // result = 31 * result + (createDate != null ? createDate.hashCode() : 0);
  // result = 31 * result + (apiKey != null ? apiKey.hashCode() : 0);
  // result = 31 * result + (int) (domainId ^ (domainId >>> 32));
  // result = 31 * result + (probeId != null ? probeId.hashCode() : 0);
  // return result;
  // }
}
